'"<$fbc>" -dll "<$file>" -x ..\JapiPlugin.dll
#include "GL\GLU.bi"
#define WIN_INCLUDEALL
#include "windows.bi"
#include "Basic4GLMacros.bi"
#include "japi.bi"
const PLUG_DESC = "for Basic4GL"
const PLUG_MAJOR = 0
const PLUG_MINOR = 1


dim shared as IDLL_Basic4GL_Plugin ptr Plugin
dim shared as HWND                     gWin
dim shared as integer                  gRunning
dim shared as string                   gPath
extern "C"

DPF(OSMsgBox) ' ASP:ASP:AIP
  MessageBox(NULL,GSP(2),GSP(3),GIP(1))
end sub

DPF(OSExecuteAndWait)
  dim as zstring ptr cmd=GSP(2)
  dim as zstring ptr arg=GSP(1)
  dim as string c=*cmd
  dim as string a=*arg
  SIR(Exec(c,a))
end sub
DPF(OSExecuteAndExit)
  dim as zstring ptr cmd=GSP(2)
  dim as zstring ptr arg=GSP(1)
  dim as string c=*cmd
  dim as string a=*arg
  SIR(Run(c,a))
end sub
DPF(OSOpenDialog)
  Dim ofn As OPENFILENAME
  Dim as zstring ptr Title =GSP(3)
  dim as integer     Flags =GIP(2)
  Dim as ubyte ptr   Filter=GSP(1)
  dim as string dialogfilter
  dim as integer i
  while Filter[i]<>0
    if Filter[i]=asc("|") then
      dialogFilter &=chr(0)
    else
      dialogFilter &=chr(Filter[i])
    end if
    i+=1
  wend
  dialogFilter &=chr(0) & chr(0)

  Dim filename As Zstring * MAX_PATH+1
  With ofn
    .lStructSize       = sizeof( OPENFILENAME )
    .hwndOwner         = gWin
    .hInstance         = GetModuleHandle( NULL )
    .lpstrFilter       = strptr(DialogFilter)
    .lpstrCustomFilter = NULL
    .nMaxCustFilter    = 0
    .nFilterIndex      = 0
    .lpstrFile         = @filename
    .nMaxFile          = sizeof( filename )
    .lpstrFileTitle    = NULL
    .nMaxFileTitle     = 0
    .lpstrInitialDir   = NULL
    .lpstrTitle        = Title
    .Flags             = Flags
    .nFileOffset       = 0
    .nFileExtension    = 0
    .lpstrDefExt       = NULL
    .lCustData         = 0
    .lpfnHook          = NULL
    .lpTemplateName    = NULL
  End With
  If( GetOpenFileName( @ofn ) = FALSE ) Then
    filename=""
  end if
  SSR(filename)
End sub

'GetSaveFilename(Title$,FLAGS,Filter)
DPF(OSSaveDialog)
  Dim ofn As OPENFILENAME
  Dim as zstring ptr Title =GSP(3)
  dim as integer     Flags =GIP(2)
  Dim as ubyte ptr Filter  =GSP(1)
  dim as string dialogfilter
  dim as integer i
  while Filter[i]<>0
    if Filter[i]=asc("|") then
      dialogFilter &=chr(0)
    else
      dialogFilter &=chr(Filter[i])
    end if
    i+=1
  wend
  dialogFilter &=chr(0) & chr(0)

  Dim filename As Zstring * MAX_PATH+1
  With ofn
    .lStructSize       = sizeof( OPENFILENAME )
    .hwndOwner         = gWin
    .hInstance         = GetModuleHandle( NULL )
    .lpstrFilter       = strptr(DialogFilter)
    .lpstrCustomFilter = NULL
    .nMaxCustFilter    = 0
    .nFilterIndex      = 0
    .lpstrFile         = @filename
    .nMaxFile          = sizeof( filename )
    .lpstrFileTitle    = NULL
    .nMaxFileTitle     = 0
    .lpstrInitialDir   = NULL
    .lpstrTitle        = Title
    .Flags             = Flags
    .nFileOffset       = 0
    .nFileExtension    = 0
    .lpstrDefExt       = NULL
    .lCustData         = 0
    .lpfnHook          = NULL
    .lpTemplateName    = NULL
  End With
  If( GetSaveFileName( @ofn ) = FALSE ) Then
    filename=""
  end if
  SSR(filename)
End sub
DPF(ACOS) ' AFP
  SFR(acos(GFP(1)))
end sub
DPF(ASIN) ' AFP
  SFR(asin(GFP(1)))
end sub

DPF(B4GLWindowShow)
  if gWin=NULL then return
  if (GIP(1)<>0) then
    ShowWindow(gWin,SW_SHOW)
  else
    ShowWindow(gWin,SW_HIDE)
  end if
end sub
DPF(B4GLWindowMove)
  if gWin=NULL then return
  SetWindowPos(gWin,NULL,GIP(2),GIP(1),0,0,SWP_ASYNCWINDOWPOS or SWP_NOZORDER or SWP_NOSIZE)
end sub
DPF(B4GLWindowResize)
  if gWin=NULL then return
  SetWindowPos(gWin,NULL,0,0,GIP(2),GIP(1),SWP_ASYNCWINDOWPOS  or SWP_NOZORDER or SWP_NOMOVE)
end sub
DPF (B4GLWindowMoveResize)
  if gWin=NULL then return
  SetWindowPos(gWin,NULL,GIP(4),GIP(3),GIP(2),GIP(1),SWP_ASYNCWINDOWPOS  or SWP_NOZORDER)
end sub
DPF(B4GLWindowSetTitle)
  SetWindowText(gWin,GSP(1))
end sub
DPF(B4GLWindowGetTitle)
  dim as zstring ptr p=callocate(1024)
  GetWindowText(gWin,p,1024)
  SSR(p)
  deallocate p
end sub
DPF(B4GLWindowOnTop)
  if (GIP(1)<>0) then
    SetWindowPos(gWin,HWND_TOPMOST,0,0,0,0,SWP_ASYNCWINDOWPOS or SWP_NOSIZE or SWP_NOMOVE)
  else
    SetWindowPos(gWin,NULL,0,0,0,0,SWP_ASYNCWINDOWPOS or SWP_NOSIZE or SWP_NOMOVE)
  end if
end sub

DPF(B4GLWindowGetRGBChannels)
  dim as integer x=GIP(7),y=GIP(6),w=GIP(5),h=GIP(4)
  dim as integer   n=w*h
  dim as ubyte ptr P = allocate(n*4)
  dim as ubyte ptr R =callocate(n*4)
  dim as ubyte ptr G =callocate(n*4)
  dim as ubyte ptr B =callocate(n*4)
  glReadPixels(x,y,w,h,GL_RGB,GL_UNSIGNED_BYTE,P)
  for i as integer=0 to n-1
    R[i*4]=P[i*3+0]
    G[i*4]=P[i*3+1]
    B[i*4]=P[i*3+2]
  next
  SIA(3,R,n):SIA(2,G,n):SIA(1,B,n)
  deallocate P
  deallocate R
  deallocate G
  deallocate B
end sub

DPF(B4GLWindowSetRGBChannels)
  dim as integer x=GIP(7),y=GIP(6),w=GIP(5),h=GIP(4)
  dim as integer   n = w*h
  dim as ubyte ptr P =callocate(n*4)
  dim as ubyte ptr R = allocate(n*4)
  dim as ubyte ptr G = allocate(n*4)
  dim as ubyte ptr B = allocate(n*4)
  GIA(3,R,n):GIA(2,G,n):GIA(1,B,n)
  for i as integer=0 to n-1
    R[i*4]=P[i*3+0]
    G[i*4]=P[i*3+1]
    B[i*4]=P[i*3+2]
  next
  glRasterPos2i(x,y)
  glDrawPixels(w,h,GL_RGB, GL_UNSIGNED_BYTE,P)
  deallocate P
  deallocate R
  deallocate G
  deallocate B
end sub

DPF(Path)
  SSR(gPath+"\")
end sub

' JAPI
DPF(j_start)
  'dim as string path=gPath & "\bin"
  'if instr(Environ("PATH"),path)=0 then
  '  SetEnviron("PATH=" & path & ";" & Environ("PATH"))
  'end if
  gRunning=j_start()
  SIR(gRunning)
end sub

DPF(j_connect)
  SIR(j_connect(GSP(1)))
end sub

DPF(j_setport)
  j_setport(GIP(1))
end sub

DPF(j_setdebug)
  j_setdebug(GIP(1))
end sub

DPF(j_quit)
  if gRunning then
    j_quit()
    gRunning=0
  end if
end sub

DPF(j_kill)
  if gRunning then j_kill()
  gRunning=0
end sub

' Components
DPF(j_frame)':ASP
  SIR(j_frame(GSP(1)))
end sub

DPF(j_button)':AIP:ASP
  SIR( j_button(GIP(2),GSP(1)) )
end sub
DPF(j_graphicbutton)':AIP:ASP
  SIR( j_graphicbutton(GIP(2),GSP(1)) )
end sub
DPF(j_checkbox)':AIP:ASP
  SIR( j_checkbox(GIP(2),GSP(1)) )
end sub
DPF(j_label)':AIP:ASP
  SIR( j_label(GIP(2),GSP(1)) )
end sub
DPF(j_graphiclabel)':AIP:ASP
  SIR( j_graphiclabel(GIP(2),GSP(1)) )
end sub
DPF(j_canvas)':AIP:AIP:AIP
  SIR( j_canvas(GIP(3),GIP(2),GIP(1)) )
end sub
DPF(j_panel)'AIP
  SIR( j_panel(GIP(1)) )
end sub
DPF(j_borderpanel)'AIP:AIP
  SIR( j_borderpanel(GIP(2),GIP(1)) )
end sub
DPF(j_radiogroup)'AIP
  SIR( j_radiogroup(GIP(1)) )
end sub
DPF(j_radiobutton)'AIP:ASP
  SIR( j_radiobutton(GIP(2),GSP(1)) )
end sub
DPF(j_list)'AIP:AIP
  SIR( j_list(GIP(2),GIP(1)) )
end sub
DPF(j_choice)'AIP
  SIR( j_choice(GIP(1)) )
end sub
DPF(j_dialog)'AIP:ASP
  SIR( j_dialog(GIP(2),GSP(1)) )
end sub
DPF(j_window)'AIP
  SIR( j_window(GIP(1)) )
end sub
DPF(j_popupmenu)'AIP:ASP
end sub
DPF(j_scrollpane)'AIP
  SIR( j_scrollpane(GIP(1)) )
end sub
DPF(j_hscrollbar)'AIP
  SIR( j_hscrollbar(GIP(1)) )
end sub
DPF(j_vscrollbar)'AIP
  SIR( j_vscrollbar(GIP(1)) )
end sub
DPF(j_line)'AIP:AIP:AIP:AIP
  SIR(j_line(GIP(4),GIP(3),GIP(2),GIP(1)))
end sub
DPF(j_printer)'AIP
  SIR( j_printer(GIP(1)) )
end sub
DPF(j_image)'AIP:AIP
  SIR(j_image(GIP(2),GIP(1)))
end sub

DPF(j_filedialog)'AIP:ASP:ASP
  SSR(j_filedialog(GIP(3),GSP(2),GSP(1),0))
end sub
' frame,"title","filter"
DPF(j_fileselect)'AIP:ASP:ASP
  SSR(j_fileselect(GIP(3),GSP(2),GSP(1),0))
end sub

DPF(j_messagebox)'AIP:ASP :ASP
  SIR(j_messagebox(GIP(3),GSP(2),GSP(1)))
end sub
DPF(j_alertbox)'AIP:ASP :ASP :ASP
  SIR(j_alertbox(GIP(4),GSP(3),GSP(2),GSP(1)))
end sub
DPF(j_choicebox2)'AIP:ASP :ASP :ASP :ASP
  SIR(j_choicebox2(GIP(5),GSP(4),GSP(3),GSP(2),GSP(1)))
end sub
DPF(j_choicebox3)'AIP:ASP :ASP :ASP :ASP :ASP
  SIR(j_choicebox3(GIP(6),GSP(5),GSP(4),GSP(3),GSP(2),GSP(1)))
end sub
DPF(j_progressbar)'AIP:AIP
  SIR(j_progressbar(GIP(2),GIP(1)))
end sub
DPF(j_led)'AIP:AIP:AIP
  SIR(j_led(GIP(3),GIP(2),GIP(1)))
end sub
DPF(j_sevensegment)'AIP:AIP
  SIR(j_sevensegment(GIP(2),GIP(1)))
end sub
DPF(j_meter)'AIP:ASP
  SIR(j_meter(GIP(2),GSP(1)))
end sub
DPF(j_additem)'AIP:ASP
  j_additem(GIP(2),GSP(1))
end sub
DPF(j_textfield)'AIP:AIP
  SIR(j_textfield(GIP(2),GIP(1)))
end sub
DPF(j_textarea)'AIP:AIP:AIP
  SIR(j_textarea(GIP(3),GIP(2),GIP(1)))
end sub
DPF(j_menubar)'AIP
  SIR( j_menubar(GIP(1)) )
end sub
DPF(j_menu)'AIP:ASP
  SIR(j_menu(GIP(2),GSP(1)))
end sub
DPF(j_helpmenu)'AIP:ASP
  SIR(j_helpmenu(GIP(2),GSP(1)))
end sub
DPF(j_menuitem)'AIP:ASP
  SIR(j_menuitem(GIP(2),GSP(1)))
end sub
DPF(j_checkmenuitem)'AIP:ASP
  SIR(j_checkmenuitem(GIP(2),GSP(1)))
end sub
DPF(j_pack)'AIP
  j_pack(GIP(1))
end sub
DPF(j_print)'AIP
  j_print(GIP(1))
end sub

DPF(j_setfont)'AIP:AIP:AIP:AIP
  j_setfont(GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_setfontname)'AIP:AIP
  j_setfontname(GIP(2),GIP(1))
end sub
DPF(j_setfontsize)'AIP:AIP
  j_setfontsize(GIP(2),GIP(1))
end sub
DPF(j_setfontstyle)'AIP:AIP
  j_setfontstyle(GIP(2),GIP(1))
end sub
DPF(j_seperator)'AIP
  j_seperator(GIP(1))
end sub
DPF(j_disable)'AIP
  j_disable(GIP(1))
end sub
DPF(j_enable)'AIP
  j_enable(GIP(1))
end sub
DPF(j_getstate)'AIP
  SIR(j_getstate(GIP(1)))
end sub
DPF(j_getrows)'AIP
  SIR(j_getrows(GIP(1)))
end sub
DPF(j_getcolumns)'AIP
  SIR(j_getcolumns(GIP(1)))
end sub
DPF(j_getselect)'AIP
  SIR(j_getselect(GIP(1)))
end sub
DPF(j_isselect)'AIP:AIP
  SIR(j_isselect(GIP(2),GIP(1)))
end sub
DPF(j_isvisible)'AIP
  SIR(j_isvisible(GIP(1)))
end sub
DPF(j_isparent)'AIP:AIP
  SIR(j_isparent(GIP(2),GIP(1)))
end sub
DPF(j_isresizable)'AIP
  SIR(j_isresizable(GIP(1)))
end sub

DPF(j_select)'AIP:AIP
  j_select(GIP(2),GIP(1))
end sub
DPF(j_deselect)'AIP:AIP
  j_deselect(GIP(2),GIP(1))
end sub
DPF(j_multiplemode)'AIP:AIP
  j_multiplemode(GIP(2),GIP(1))
end sub
DPF(j_insert)'AIP:AIP:ASP
  j_insert(GIP(3),GIP(2),GSP(1))
end sub
DPF(j_remove)'AIP:AIP
  j_remove(GIP(2),GIP(1))
end sub
DPF(j_removeitem)'AIP:ASP
  j_removeitem(GIP(2),GSP(1))
end sub
DPF(j_removeall)'AIP
  j_removeall(GIP(1))
end sub
DPF(j_setstate)'AIP:AIP
  j_setstate(GIP(2),GIP(1))
end sub
DPF(j_setrows)'AIP:AIP
  j_setrows(GIP(2),GIP(1))
end sub
DPF(j_setcolumns)'AIP:AIP
  j_setcolumns(GIP(2),GIP(1))
end sub
DPF(j_seticon)'AIP:AIP
  j_seticon(GIP(2),GIP(1))
end sub
DPF(j_setimage)'AIP:AIP
  j_setimage(GIP(2),GIP(1))
end sub
DPF(j_setvalue)'AIP:AIP
  j_setvalue(GIP(2),GIP(1))
end sub
DPF(j_setradiogroup)'AIP:AIP
  j_setradiogroup(GIP(2),GIP(1))
end sub
DPF(j_setunitinc)'AIP:AIP
  j_setunitinc(GIP(2),GIP(1))
end sub
DPF(j_setblockinc)'AIP:AIP
  j_setblockinc(GIP(2),GIP(1))
end sub
DPF(j_setmin)'AIP:AIP
  j_setmin(GIP(2),GIP(1))
end sub
DPF(j_setmax)'AIP:AIP
  j_setmax(GIP(2),GIP(1))
end sub
DPF(j_setdanger)'AIP:AIP
  j_setdanger(GIP(2),GIP(1))
end sub
DPF(j_setslidesize)'AIP:AIP
  j_setslidesize(GIP(2),GIP(1))
end sub
DPF(j_setcursor)'AIP:AIP
  j_setcursor(GIP(2),GIP(1))
end sub
DPF(j_setresizable)'AIP:AIP
  j_setresizable(GIP(2),GIP(1))
end sub

DPF(j_getlength)'AIP
  SIR(j_getlength(GIP(1)))
end sub
DPF(j_getvalue)'AIP
  SIR(j_getvalue(GIP(1)))
end sub
DPF(j_getdanger)'AIP
  SIR(j_getdanger(GIP(1)))
end sub
DPF(j_getscreenheight)
  SIR(j_getscreenheight())
end sub
DPF(j_getscreenwidth)
  SIR(j_getscreenwidth())
end sub
DPF(j_getheight)'AIP
  SIR(j_getheight(GIP(1)))
end sub
DPF(j_getwidth)'AIP
  SIR(j_getwidth(GIP(1)))
end sub
DPF(j_getinsets)'AIP:AIP
  SIR(j_getinsets(GIP(2),GIP(1)))
end sub
DPF(j_getlayoutid)'AIP
  SIR(j_getlayoutid(GIP(1)))
end sub
DPF(j_getinheight)'AIP
  SIR(j_getinheight(GIP(1)))
end sub
DPF(j_getinwidth)'AIP
  SIR(j_getinwidth(GIP(1)))
end sub
DPF(j_gettext)'AIP
  SSR(j_gettext(GIP(1),0))
end sub
DPF(j_getitem)'AIP:AIP
  SSR(j_getitem(GIP(2),GIP(1),0))
end sub
DPF(j_getitemcount)'AIP
  SIR(j_getitemcount(GIP(1)))
end sub

DPF(j_delete)'AIP:AIP:AIP
  j_delete(GIP(3),GIP(2),GIP(1))
end sub
DPF(j_replacetext)'AIP:ASP:AIP:AIP
  j_replacetext(GIP(4),GSP(3),GIP(2),GIP(1))
end sub
DPF(j_appendtext)'AIP:ASP
  j_appendtext(GIP(2),GSP(1))
end sub
DPF(j_inserttext)'AIP:ASP :AIP
  j_inserttext(GIP(3),GSP(2),GIP(1))
end sub
DPF(j_settext)'AIP:ASP
  j_settext(GIP(2),GSP(1))
end sub
DPF(j_selectall)'AIP
  j_selectall(GIP(1))
end sub
DPF(j_selecttext)'AIP:AIP:AIP
  j_selecttext(GIP(3),GIP(2),GIP(1))
end sub

DPF(j_getselstart)'AIP
  SIR(j_getselstart(GIP(1)))
end sub
DPF(j_getselend)'AIP
  SIR(j_getselend(GIP(1)))
end sub
DPF(j_getseltext)'AIP
  SSR(j_getseltext(GIP(1),0))
end sub
DPF(j_getcurpos)'AIP
  SIR(j_getcurpos(GIP(1)))
end sub

DPF(j_setcurpos)'AIP:AIP
  j_setcurpos(GIP(2),GIP(1))
end sub
DPF(j_setechochar)'AIP, char
  j_setechochar(GIP(2),GIP(1))
end sub
DPF(j_seteditable)'AIP:AIP
  j_seteditable(GIP(2),GIP(1))
end sub
DPF(j_setshortcut)'AIP, char
  j_setshortcut(GIP(2),GIP(1))
end sub

DPF(j_setsize)'AIP:AIP:AIP
  j_setsize(GIP(3),GIP(2),GIP(1))
end sub

DPF(j_getaction)'void
  SIR(j_getaction())
end sub
DPF(j_nextaction)'void
  SIR(j_nextaction())
end sub

DPF(j_show)'AIP
  j_show(GIP(1))  
end sub
DPF(j_showpopup)'AIP:AIP:AIP
  j_showpopup(GIP(3),GIP(2),GIP(1))
end sub
DPF(j_add)'AIP:AIP
  j_add(GIP(2),GIP(1))
end sub
DPF(j_release)'AIP
  j_release(GIP(1))
end sub
DPF(j_releaseall)'AIP
  j_releaseall(GIP(1))
end sub
DPF(j_hide)'AIP
  j_hide(GIP(1))
end sub
DPF(j_dispose)'AIP
  j_dispose(GIP(1))
end sub
DPF(j_setpos)'AIP:AIP:AIP
  j_setpos(GIP(3),GIP(2),GIP(1))
end sub

DPF(j_getviewportheight)'AIP
  SIR(j_getviewportheight(GIP(1)))
end sub
DPF(j_getviewportwidth)'AIP
  SIR(j_getviewportwidth(GIP(1)))
end sub
DPF(j_getxpos)'AIP
  SIR(j_getxpos(GIP(1)))
end sub
DPF(j_getypos)'AIP
  SIR(j_getypos(GIP(1)))
end sub

DPF(j_getpos)'AIP:AIPR:AIPR
  dim as integer x,y
  j_getpos(GIP(3),@x,@y)
  SIPR(2,@x)
  SIPR(1,@y)
end sub

DPF(j_getparentid)'AIP
  SIR(j_getparentid(GIP(1)))
end sub

DPF(j_setfocus)'AIP
  j_setfocus(GIP(1))
end sub

DPF(j_hasfocus)'AIP
  SIR(j_hasfocus(GIP(1)))
end sub
DPF(j_getstringwidth)'AIP:ASP
  SIR(j_getstringwidth(GIP(2),GSP(1)))
end sub
DPF(j_getfontheight)'AIP
  SIR(j_getfontheight(GIP(1)))
end sub
DPF(j_getfontascent)'AIP
  SIR(j_getfontascent(GIP(1)))
end sub
DPF(j_keylistener)'AIP
  SIR(j_keylistener(GIP(1)))
end sub
DPF(j_getkeycode)'AIP
  SIR(j_getkeycode(GIP(1)))
end sub
DPF(j_getkeychar)'AIP
  SIR(j_getkeychar(GIP(1)))
end sub
DPF(j_mouselistener)'AIP:AIP
  SIR(j_mouselistener(GIP(2),GIP(1)))
end sub
DPF(j_getmousex)'AIP
  SIR(j_getmousex(GIP(1)))
end sub
DPF(j_getmousey)'AIP
  SIR(j_getmousey(GIP(1)))
end sub
DPF(j_getmousepos)'AIP:AIPR:AIPR
  dim as integer x,y
  j_getmousepos(GIP(3),@x,@y)
  SIPR(2,@x)
  SIPR(1,@y)
end sub
DPF(j_getmousebutton)'AIP
  SIR(j_getmousebutton(GIP(1)))
end sub
DPF(j_focuslistener)'AIP
  SIR(j_focuslistener(GIP(1)))
end sub
DPF(j_componentlistener)'AIP:AIP
  SIR(j_componentlistener(GIP(2),GIP(1)))
end sub
DPF(j_windowlistener)'AIP:AIP
  SIR(j_windowlistener(GIP(2),GIP(1)))
end sub

DPF(j_setflowlayout)'AIP:AIP
  j_setflowlayout(GIP(2),GIP(1))
end sub
DPF(j_setborderlayout)'AIP
  j_setborderlayout(GIP(1))
end sub
DPF(j_setgridlayout)'AIP:AIP:AIP
  j_setgridlayout(GIP(3),GIP(2),GIP(1))
end sub
DPF(j_setfixlayout)'AIP
  j_setfixlayout(GIP(1))
end sub
DPF(j_setnolayout)'AIP
  j_setnolayout(GIP(1))
end sub
DPF(j_setborderpos)'AIP:AIP
  j_setborderpos(GIP(2),GIP(1))
end sub
DPF(j_sethgap)'AIP:AIP
  j_sethgap(GIP(2),GIP(1))
end sub
DPF(j_setvgap)'AIP:AIP
  j_setvgap(GIP(2),GIP(1))
end sub
DPF(j_setinsets)'AIP:AIP:AIP:AIP:AIP
  j_setinsets(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_setalign)'AIP:AIP
  j_setalign(GIP(2),GIP(1))
end sub
DPF(j_setflowfill)'AIP:AIP
  j_setflowfill(GIP(2),GIP(1))
end sub
DPF(j_translate)'AIP:AIP:AIP
  j_translate(GIP(3),GIP(2),GIP(1))
end sub
DPF(j_cliprect)'AIP:AIP:AIP:AIP:AIP
  j_cliprect(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawrect)'AIP:AIP:AIP:AIP:AIP
  j_drawrect(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_fillrect)'AIP:AIP:AIP:AIP:AIP
  j_fillrect(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawroundrect)'AIP:AIP:AIP:AIP:AIP:AIP:AIP
  j_drawroundrect(GIP(7),GIP(6),GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_fillroundrect)'AIP:AIP:AIP:AIP:AIP:AIP:AIP
  j_fillroundrect(GIP(7),GIP(6),GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawoval)'AIP:AIP:AIP:AIP:AIP
  j_drawoval(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_filloval)'AIP:AIP:AIP:AIP:AIP
  j_filloval(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawcircle)'AIP:AIP:AIP:AIP
  j_drawcircle(GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_fillcircle)'AIP:AIP:AIP:AIP
  j_fillcircle(GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawarc)'AIP:AIP:AIP:AIP:AIP:AIP:AIP
  j_drawarc(GIP(7),GIP(6),GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_fillarc)'AIP:AIP:AIP:AIP:AIP:AIP:AIP
  j_fillarc(GIP(7),GIP(6),GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawline)'AIP:AIP:AIP:AIP:AIP
  j_drawline(GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawpolyline)'AIP:AIP:AAIP(1) :AAIP(1)
  dim as integer n=GIP(3)
  dim as integer ptr pX=allocate(n*4)
  dim as integer ptr pY=allocate(n*4)
  GIA(2,pX,n):GIA(1,pY,n):
  j_drawpolyline(GIP(4),n,pX,pY)
  deallocate(pX):deallocate(pY)
end sub

DPF(j_drawpolygon)'AIP:AIP:AAIP(1) :AAIP(1)
  dim as integer n=GIP(3)
  dim as integer ptr pX=allocate(n*4)
  dim as integer ptr pY=allocate(n*4)
  GIA(2,pX,n):GIA(1,pY,n)
  j_drawpolygon(GIP(4),n,pX,pY)
  deallocate(pX):deallocate(pY)
end sub
DPF(j_fillpolygon)'AIP:AIP:AAIP(1) :AAIP(1)
  dim as integer n=GIP(3)
  dim as integer ptr pX=allocate(n*4)
  dim as integer ptr pY=allocate(n*4)
  GIA(2,pX,n):GIA(1,pY,n)
  j_fillpolygon(GIP(4),n,pX,pY)
  deallocate(pX):deallocate(pY)
end sub
DPF(j_drawpixel)'AIP:AIP:AIP
  j_drawpixel(GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawstring)'AIP:AIP:AIP:ASP
  j_drawstring(GIP(4),GIP(3),GIP(2),GSP(1))
end sub
DPF(j_setxor)'AIP:AIP
  j_setxor(GIP(2),GIP(1))
end sub

' image
DPF(j_getimage)'AIP
  j_getimage(GIP(1))
end sub
DPF(j_getscaledimage)'AIP:AIP:AIP:AIP:AIP:AIP:AIP
  SIR(j_getscaledimage(GIP(7),GIP(6),GIP(5),GIP(4),GIP(3),GIP(2),GIP(1)))
end sub
DPF(j_getimagesource)'AIP:AIP:AIP:AIP:AIP:AAIP(1) :AAIP(1) :AAIP(1)
  dim as integer h=GIP(4)
  dim as integer w=GIP(5)
  dim as integer y=GIP(6)
  dim as integer x=GIP(7)
  dim as integer n = w*h,i
  if n<1 then return
  dim as integer ptr pR=allocate(n*4)
  dim as integer ptr pG=allocate(n*4)
  dim as integer ptr pB=allocate(n*4)
  j_getimagesource(GIP(8),x,y,w,h,pR,pG,pB)
  for i=0 to n-1
    pR[i] and=255
    pG[i] and=255
    pB[i] and=255
  next
  SIA(3,pR,n):SIA(2,pG,n):SIA(1,pB,n)
  deallocate(pR):deallocate(pG):deallocate(pB)
end sub

DPF(j_drawimage)'AIP:AIP:AIP:AIP
  j_drawimage(GIP(4),GIP(3),GIP(2),GIP(1))
end sub

DPF(j_drawscaledimage)'AIP:AIP:AIP:AIP:AIP:AIP:AIP:AIP:AIP:AIP
  j_drawscaledimage(GIP(10),GIP(9),GIP(8),GIP(7),GIP(6),GIP(5),GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_drawimagesource)'AIP:AIP:AIP:AIP:AIP:AAIP(1) :AAIP(1) :AAIP(1)
  dim as integer h=GIP(4)
  dim as integer w=GIP(5)
  dim as integer y=GIP(6)
  dim as integer x=GIP(7)
  dim as integer n = w*h
  dim as integer ptr pR=allocate(n*4)
  dim as integer ptr pG=allocate(n*4)
  dim as integer ptr pB=allocate(n*4)

  GIA(3,pR,n):GIA(2,pG,n):GIA(1,pB,n)
  j_drawimagesource(GIP(8),x,y,w,h,pR,pG,pB)
  deallocate(pR):deallocate(pG):deallocate(pB)
end sub

DPF(j_setcolor)'AIP:AIP:AIP:AIP
  j_setcolor(GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_setcolorbg)'AIP:AIP:AIP:AIP
  j_setcolorbg(GIP(4),GIP(3),GIP(2),GIP(1))
end sub
DPF(j_setnamedcolor)'AIP:AIP
  j_setnamedcolor(GIP(2),GIP(1))
end sub
DPF(j_setnamedcolorbg)'AIP:AIP
  j_setnamedcolorbg(GIP(2),GIP(1))
end sub

DPF(j_loadimage)'ASP
  SIR(j_loadimage(GSP(1)))
end sub
DPF(j_saveimage)'AIP:ASP :AIP
  SIR(j_saveimage(GIP(3),GSP(2),GIP(1)))
end sub

DPF(j_sync)
  j_sync()
end sub
DPF(j_beep)
  j_beep()
end sub

DPF(j_random)
  SIR(j_random())
end sub

DPF(j_sleep)'AIP
  j_sleep(GIP(1))
end sub

' ##########
' # Plugin #
' ##########
function Load(THIS_PLUGIN  , _
              THIS_REGISTRY, _
              blnIsExe as byte) as byte
  gPath=CurDir()

  RIF(OSMsgBox):ASP:ASP:AIP
  RIF(OSExecuteAndWait):ASP:ASP
  RIF(OSExecuteAndExit):ASP:ASP
  RIC(ENABLESIZING,OFN_CREATEPROMPT)
  RIC(CREATEPROMPT,OFN_CREATEPROMPT)
  RIC(PATHMUSTEXIST,OFN_PATHMUSTEXIST)
  RIC(FILEMUSTEXIST,OFN_FILEMUSTEXIST)
  RIC(HIDEREADONLY,OFN_HIDEREADONLY)
  RIC(NONETWORKBUTTON,OFN_NONETWORKBUTTON)
  RIC(OVERWRITEPROMPT,OFN_OVERWRITEPROMPT)
  RIC(READONLY,OFN_READONLY) 
  RSF(OSOpenDialog):ASP:AIP:ASP
  RSF(OSSaveDialog):ASP:AIP:ASP


  RIC(MBICONERROR,MB_ICONERROR)
  RIC(MBICONQUESTION,MB_ICONQUESTION)
  RIC(MBICONWARNING,MB_ICONWARNING)
  RIC(MBICONASTERISK,MB_ICONASTERISK)

  RIC(MBDEFBUTTON2,MB_DEFBUTTON2)
  RIC(MBDEFBUTTON3,MB_DEFBUTTON3)
  RIC(MBDEFBUTTON4,MB_DEFBUTTON3)

  RIC(MBOK,MB_OK)
  RIC(MBOKCANCEL,MB_OKCANCEL)
  RIC(MBYESNOCANCEL,MB_YESNOCANCEL)
  RIC(MBYESNO,MB_YESNO)
  RIC(MBRETRYCANCEL,MB_RETRYCANCEL)

  RIC(MBIDOK,IDOK)
  RIC(MBIDCANCEL,IDCANCEL)
  RIC(MBIDABORT,IDABORT)
  RIC(MBIDRETRY,IDRETRY)
  RIC(MBIDIGNORE,IDIGNORE)
  RIC(MBIDYES,IDYES)
  RIC(MBIDNO,IDNO)
  RIC(MBIDCLOSE,IDCLOSE)

  RFF(ACos):AFP
  RFF(ASin):AFP

  RVF(B4GLWindowShow):AIP
  RVF(B4GLWindowMove):AIP:AIP
  RVF(B4GLWindowResize):AIP:AIP
  RVF(B4GLWindowMoveResize):AIP:AIP:AIP:AIP
  RVF(B4GLWindowOnTop):AIP
  RVF(B4GLWindowSetTitle):ASP
  RSF(B4GLWindowGetTitle)

  RVF(B4GLWindowGetRGBChannels):AIP:AIP:AIP:AIP:AAIP(1):AAIP(1):AAIP(1)
  RVF(B4GLWindowSetRGBChannels):AIP:AIP:AIP:AIP:AAIP(1):AAIP(1):AAIP(1)

  RSF(Path)

   '  BOOLEAN
  RIC(J_TRUE,1)
  RIC(J_FALSE,0)
  '  ALIGNMENT
  RIC(J_LEFT,0)
  RIC(J_CENTER,1)
  RIC(J_RIGHT,2)
  RIC(J_TOP,3)
  RIC(J_BOTTOM,4)
  RIC(J_TOPLEFT,5)
  RIC(J_TOPRIGHT,6)
  RIC(J_BOTTOMLEFT,7)
  RIC(J_BOTTOMRIGHT,8)
  '  CURSOR
  RIC(J_DEFAULT_CURSOR,0)
  RIC(J_CROSSHAIR_CURSOR,1)
  RIC(J_TEXT_CURSOR,2)
  RIC(J_WAIT_CURSOR,3)
  RIC(J_SW_RESIZE_CURSOR,4)
  RIC(J_SE_RESIZE_CURSOR,5)
  RIC(J_NW_RESIZE_CURSOR,6)
  RIC(J_NE_RESIZE_CURSOR,7)
  RIC(J_N_RESIZE_CURSOR,8)
  RIC(J_S_RESIZE_CURSOR,9)
  RIC(J_W_RESIZE_CURSOR,10)
  RIC(J_E_RESIZE_CURSOR,11)
  RIC(J_HAND_CURSOR,12)
  RIC(J_MOVE_CURSOR,13)
  '  ORIENTATION
  RIC(J_HORIZONTAL,0)
  RIC(J_VERTICAL  ,1)

  '  FONTS
  RIC(J_PLAIN    ,0)
  RIC(J_BOLD     ,1)
  RIC(J_ITALIC   ,2)
  RIC(J_COURIER  ,1)
  RIC(J_HELVETIA ,2)
  RIC(J_TIMES    ,3)
  RIC(J_DIALOGIN ,4)
  RIC(J_DIALOGOUT,5)

  '  COLORS
  RIC(J_BLACK       ,0)
  RIC(J_WHITE       ,1)
  RIC(J_RED         ,2)
  RIC(J_GREEN       ,3)
  RIC(J_BLUE        ,4)
  RIC(J_CYAN        ,5)
  RIC(J_MAGENTA     ,6)
  RIC(J_YELLOW      ,7)
  RIC(J_ORANGE      ,8)
  RIC(J_GREEN_YELLOW,9)
  RIC(J_GREEN_CYAN  ,10)
  RIC(J_BLUE_CYAN   ,11)
  RIC(J_BLUE_MAGENTA,12)
  RIC(J_RED_MAGENTA ,13)
  RIC(J_DARK_GRAY   ,14)
  RIC(J_LIGHT_GRAY  ,15)
  RIC(J_GRAY        ,16)
  '  BORDERSTYLE
  RIC(J_NONE    ,0)
  RIC(J_LINEDOWN,1)
  RIC(J_LINEUP  ,2)
  RIC(J_AREADOWN,3)
  RIC(J_AREAUP  ,4)
  '  MOUSELISTENER
  RIC(J_MOVED      ,0)
  RIC(J_DRAGGED    ,1)
  RIC(J_PRESSED    ,2)
  RIC(J_RELEASED   ,3)
  RIC(J_ENTERERD   ,4)
  RIC(J_EXITED     ,5)
  RIC(J_DOUBLECLICK,6)
  '  COMPONENTLISTENER
  'RIC(J_MOVED  ,0)
  RIC(J_RESIZED,1)
  RIC(J_HIDDEN ,2)
  RIC(J_SHOWN  ,3)
  '  WINDOWLISTENER
  RIC(J_ACTIVATED  ,0)
  RIC(J_DEACTIVATED,1)
  RIC(J_OPENED     ,2)
  RIC(J_CLOSED     ,3)
  RIC(J_ICONIFIED  ,4)
  RIC(J_DEICONIFIED,5)
  RIC(J_CLOSING    ,6)
  '  IMAGEFILEFORMAT
  RIC(J_GIF,0)
  RIC(J_JPG,1)
  RIC(J_PPM,2)
  RIC(J_BMP,3)
  '  LEDFORMAT
  RIC(J_ROUND,0)
  RIC(J_RECT ,1)
  '  RANDOMMAX
  RIC(J_RANDMAX,2147483647)

  RIF(j_start):TimeShare
  RIF(j_connect):ASP:TimeShare
  RVF(j_setport):AIP
  RVF(j_setdebug):AIP
  RVF(j_sync)
  RVF(j_quit):TimeShare
  RVF(j_kill)

  ' Components 
  RIF(j_frame):ASP
  RIF(j_canvas):AIP:AIP:AIP
  RIF(j_image):AIP:AIP
  RIF(j_window):AIP
  RIF(j_dialog):AIP:ASP
  
  RIF(j_panel):AIP
  RIF(j_borderpanel):AIP:AIP
  
  RIF(j_messagebox):AIP:ASP:ASP
  RIF(j_alertbox):AIP:ASP:ASP:ASP

  RIF(j_menubar):AIP
  RIF(j_menu):AIP:ASP
  RIF(j_helpmenu):AIP:ASP
  RIF(j_menuitem):AIP:ASP
  RIF(j_checkmenuitem):AIP:ASP
  RIF(j_popupmenu):AIP:ASP

  RIF(j_button):AIP:ASP
  RIF(j_graphicbutton):AIP:ASP
  
  RIF(j_label):AIP:ASP
  RIF(j_graphiclabel):AIP:ASP
    
  RIF(j_checkbox):AIP:ASP
  RIF(j_radiogroup):AIP
  RIF(j_radiobutton):AIP:ASP
  
  RIF(j_list):AIP:AIP
  RIF(j_choice):AIP
    
  RIF(j_textfield):AIP:AIP
  RIF(j_textarea):AIP:AIP:AIP
  
  RIF(j_scrollpane):AIP
  RIF(j_hscrollbar):AIP
  RIF(j_vscrollbar):AIP

  RIF(j_line):AIP:AIP:AIP:AIP

  RIF(j_printer):AIP

  RSF(j_filedialog):AIP:ASP:ASP
  RSF(j_fileselect):AIP:ASP:ASP
  
  RIF(j_choicebox2):AIP:ASP:ASP:ASP:ASP
  RIF(j_choicebox3):AIP:ASP:ASP:ASP:ASP:ASP
  RIF(j_progressbar):AIP:AIP
  RIF(j_led):AIP:AIP:AIP
  RIF(j_sevensegment):AIP:AIP
  RIF(j_meter):AIP:ASP


  RVF(j_additem):AIP:ASP

  RVF(j_pack):AIP
  RVF(j_print):AIP

  RVF(j_setfont):AIP:AIP:AIP:AIP
  RVF(j_setfontname):AIP:AIP
  RVF(j_setfontsize):AIP:AIP
  RVF(j_setfontstyle):AIP:AIP
  RVF(j_seperator):AIP
  RVF(j_disable):AIP
  RVF(j_enable):AIP
  RIF(j_getstate):AIP
  RIF(j_getrows):AIP
  RIF(j_getcolumns):AIP
  RIF(j_getselect):AIP
  RIF(j_isselect):AIP:AIP
  RIF(j_isvisible):AIP
  RIF(j_isparent):AIP:AIP
  RIF(j_isresizable):AIP
  RVF(j_select):AIP:AIP
  RVF(j_deselect):AIP:AIP
  RVF(j_multiplemode):AIP:AIP
  RVF(j_insert):AIP:AIP:ASP
  RVF(j_remove):AIP:AIP
  RVF(j_removeitem):AIP:ASP
  RVF(j_removeall):AIP
  RVF(j_setstate):AIP:AIP
  RVF(j_setrows):AIP:AIP
  RVF(j_setcolumns):AIP:AIP
  RVF(j_seticon):AIP:AIP
  RVF(j_setimage):AIP:AIP
  RVF(j_setvalue):AIP:AIP
  RVF(j_setradiogroup):AIP:AIP
  RVF(j_setunitinc):AIP:AIP
  RVF(j_setblockinc):AIP:AIP
  RVF(j_setmin):AIP:AIP
  RVF(j_setmax):AIP:AIP
  RVF(j_setdanger):AIP:AIP
  RVF(j_setslidesize):AIP:AIP
  RVF(j_setcursor):AIP:AIP
  RVF(j_setresizable):AIP:AIP
  RIF(j_getlength):AIP
  RIF(j_getvalue):AIP
  RIF(j_getdanger):AIP
  RIF(j_getscreenheight)
  RIF(j_getscreenwidth)
  RIF(j_getheight):AIP
  RIF(j_getwidth):AIP
  RIF(j_getinsets):AIP:AIP
  RIF(j_getlayoutid):AIP
  RIF(j_getinheight):AIP
  RIF(j_getinwidth):AIP
  RSF(j_gettext):AIP
  RSF(j_getitem):AIP:AIP
  RIF(j_getitemcount):AIP
  RVF(j_delete):AIP:AIP:AIP
  RVF(j_replacetext):AIP:ASP :AIP:AIP
  RVF(j_appendtext):AIP:ASP
  RVF(j_inserttext):AIP:ASP :AIP
  RVF(j_settext):AIP:ASP
  RVF(j_selectall):AIP
  RVF(j_selecttext):AIP:AIP:AIP
  RIF(j_getselstart):AIP
  RIF(j_getselend):AIP
  RSF(j_getseltext):AIP
  RIF(j_getcurpos):AIP

  RVF(j_setcurpos):AIP:AIP
  RVF(j_setechochar):AIP:AIP
  RVF(j_seteditable):AIP:AIP
  RVF(j_setshortcut):AIP:AIP
  
  RVF(j_setsize):AIP:AIP:AIP

  RIF(j_getaction)
  RIF(j_nextaction)

  RVF(j_show):AIP
  RVF(j_showpopup):AIP:AIP:AIP
  RVF(j_add):AIP:AIP
  RVF(j_release):AIP
  RVF(j_releaseall):AIP
  RVF(j_hide):AIP
  RVF(j_dispose):AIP
  RVF(j_setpos):AIP:AIP:AIP

  RIF(j_getviewportheight):AIP
  RIF(j_getviewportwidth):AIP
  RIF(j_getxpos):AIP
  RIF(j_getypos):AIP

  RVF(j_getpos):AIP:AIPR:AIPR

  RIF(j_getparentid):AIP

  RVF(j_setfocus):AIP

  RIF(j_hasfocus):AIP
  RIF(j_getstringwidth):AIP:ASP
  RIF(j_getfontheight):AIP
  RIF(j_getfontascent):AIP
  
  RIF(j_keylistener):AIP
  RIF(j_getkeycode):AIP
  RIF(j_getkeychar):AIP

  RIF(j_mouselistener):AIP:AIP
  RIF(j_getmousex):AIP
  RIF(j_getmousey):AIP
  RVF(j_getmousepos):AIP:AIPR:AIPR
  RIF(j_getmousebutton):AIP
  
  RIF(j_focuslistener):AIP
  RIF(j_componentlistener):AIP:AIP
  RIF(j_windowlistener):AIP:AIP

  RVF(j_setflowlayout):AIP:AIP
  RVF(j_setborderlayout):AIP
  RVF(j_setgridlayout):AIP:AIP:AIP
  RVF(j_setfixlayout):AIP
  RVF(j_setnolayout):AIP

  RVF(j_setborderpos):AIP:AIP
  RVF(j_sethgap):AIP:AIP
  RVF(j_setvgap):AIP:AIP
  RVF(j_setinsets):AIP:AIP:AIP:AIP:AIP
  RVF(j_setalign):AIP:AIP
  RVF(j_setflowfill):AIP:AIP
  RVF(j_translate):AIP:AIP:AIP
  RVF(j_cliprect):AIP:AIP:AIP:AIP:AIP
  RVF(j_drawrect):AIP:AIP:AIP:AIP:AIP
  RVF(j_fillrect):AIP:AIP:AIP:AIP:AIP
  RVF(j_drawroundrect):AIP:AIP:AIP:AIP:AIP:AIP:AIP
  RVF(j_fillroundrect):AIP:AIP:AIP:AIP:AIP:AIP:AIP
  RVF(j_drawoval):AIP:AIP:AIP:AIP:AIP
  RVF(j_filloval):AIP:AIP:AIP:AIP:AIP
  RVF(j_drawcircle):AIP:AIP:AIP:AIP
  RVF(j_fillcircle):AIP:AIP:AIP:AIP
  RVF(j_drawarc):AIP:AIP:AIP:AIP:AIP:AIP:AIP
  RVF(j_fillarc):AIP:AIP:AIP:AIP:AIP:AIP:AIP
  RVF(j_drawline):AIP:AIP:AIP:AIP:AIP
  RVF(j_drawpolyline):AIP:AIP:AAIP(1) :AAIP(1)
  RVF(j_drawpolygon):AIP:AIP:AAIP(1) :AAIP(1)
  RVF(j_fillpolygon):AIP:AIP:AAIP(1) :AAIP(1)
  RVF(j_drawpixel):AIP:AIP:AIP
  RVF(j_drawstring):AIP:AIP:AIP:ASP
  RVF(j_setxor):AIP:AIP

  RIF(j_getimage):AIP
  RIF(j_getscaledimage):AIP:AIP:AIP:AIP:AIP:AIP:AIP
  RVF(j_getimagesource):AIP:AIP:AIP:AIP:AIP:AAIP(1) :AAIP(1) :AAIP(1)
  RVF(j_drawimagesource):AIP:AIP:AIP:AIP:AIP:AAIP(1) :AAIP(1) :AAIP(1)
  RVF(j_drawimage):AIP:AIP:AIP:AIP

  RVF(j_drawscaledimage):AIP:AIP:AIP:AIP:AIP:AIP:AIP:AIP:AIP:AIP

  RVF(j_setcolor):AIP:AIP:AIP:AIP
  RVF(j_setcolorbg):AIP:AIP:AIP:AIP
  RVF(j_setnamedcolor):AIP:AIP
  RVF(j_setnamedcolorbg):AIP:AIP

  RIF(j_loadimage):ASP
  RIF(j_saveimage):AIP:ASP :AIP

  
  RVF(j_beep)

  RIF(j_random)

  RVF(j_sleep):AIP: TimeShare

  return 1
end function

sub Unload (THIS_PLUGIN)
  if gRunning then 
    j_quit()
    'j_kill()
    gRunning=0
  end if
  delete Plugin
end sub

function Start (THIS_PLUGIN) as byte
  gWin=FindWindow("gbOPENGL",NULL)
  return 1
end function

sub Ends (THIS_PLUGIN)
  if gRunning then 
    j_kill()
    gRunning=0
  end if
end sub
sub      Pause (THIS_PLUGIN)

end sub
sub      Resumed (THIS_PLUGIN)

end sub
sub      DelayedResume (THIS_PLUGIN)

end sub
sub      GetError  (THIS_PLUGIN,ErrMsg as zstring ptr)

end sub
sub      ProcessMessages(THIS_PLUGIN)

end sub

' Query function
function Basic4GL_Query  alias "Basic4GL_Query" (byval details as string, _
                                                 byref major   as integer, _
                                                 byref minor   as integer) as integer export
  dim as string detailSrc = PLUG_DESC
  for i as integer = 0 to len(detailSrc)
    details[i] = detailSrc[i]
  next
  major = PLUG_MAJOR
  minor = PLUG_MINOR
  return BASIC4GL_DLL_VERSION
end function



' Main initialisation function.
' Here we will construct and return our plugin object
function Basic4GL_Init  alias "Basic4GL_Init" () as IDLL_Basic4GL_Plugin ptr ptr export
  Plugin=new IDLL_Basic4GL_Plugin
  ' Construct and return our plugin object
  Plugin->Load           =@Load
  Plugin->Unload         =@Unload
  Plugin->Start          =@Start
  Plugin->Ends           =@Ends
  Plugin->Pause          =@Pause
  Plugin->Resumed        =@Resumed
  Plugin->DelayedResume  =@DelayedResume
  Plugin->GetError       =@GetError
  Plugin->ProcessMessages=@ProcessMessages
  return @Plugin
end function

end extern
