#ifndef __japi_bi__
#define __japi_bi__



#ifdef __FB_WIN32__
'#inclib "coldname"
# include "win\winsock2.bi"
# inclib "japi"
#else
# inclib "japilin"
#endif

#if 1
enum J_BOOL
  J_FALSE
  J_TRUE
end enum

enum J_ALIGNMENT
 J_LEFT
 J_CENTER
 J_RIGHT
 J_TOP
 J_BOTTOM
 J_TOPLEFT
 J_TOPRIGHT
 J_BOTTOMLEFT
 J_BOTTOMRIGHT
end enum

enum J_CURSOR
 J_DEFAULT_CURSOR
 J_CROSSHAIR_CURSOR
 J_TEXT_CURSOR
 J_WAIT_CURSOR
 J_SW_RESIZE_CURSOR
 J_SE_RESIZE_CURSOR
 J_NW_RESIZE_CURSOR
 J_NE_RESIZE_CURSOR
 J_N_RESIZE_CURSOR
 J_S_RESIZE_CURSOR
 J_W_RESIZE_CURSOR
 J_E_RESIZE_CURSOR
 J_HAND_CURSOR
 J_MOVE_CURSOR
end enum

enum J_ORIENTATION
  J_HORIZONTAL
  J_VERTICAL
end enum

enum J_FONTNAME
 J_DEFAULT
 J_COURIER
 J_HELVETIA
 J_TIMES
 J_DIALOGIN
 J_DIALOGOUT
end enum

enum J_FONTSTYLE
 J_PLAIN
 J_BOLD
 J_ITALIC
end enum

enum J_NAMEDCOLOR
 J_BLACK
 J_WHITE
 J_RED
 J_GREEN
 J_BLUE
 J_CYAN
 J_MAGENTA
 J_YELLOW
 J_ORANGE
 J_GREEN_YELLOW
 J_GREEN_CYAN
 J_BLUE_CYAN
 J_BLUE_MAGENTA
 J_RED_MAGENTA
 J_DARK_GRAY
 J_LIGHT_GRAY
 J_GRAY
end enum

enum J_BORDERSTYLE
 J_NONE
 J_LINEDOWN
 J_LINEUP
 J_AREADOWN
 J_AREAUP
end enum

enum J_MOUSEEVENT
 J_MOVED
 J_DRAGGED
 J_PRESSED
 J_RELEASED
 J_ENTERERD
 J_EXITED
 J_DOUBLECLICK
end enum

enum J_COMPONETEVENT
 J_RESIZED = 1
 J_HIDDEN
 J_SHOWN
end enum

enum J_WINDOWEVENT
 J_ACTIVATED
 J_DEACTIVATED
 J_OPENED
 J_CLOSED
 J_ICONIFIED
 J_DEICONIFIED
 J_CLOSING
end enum

enum J_LOADFORMAT
 J_LOADGIF
 J_LOADJPG
 J_LOADPPM
 J_LOADBMP
end enum

enum J_SAVEFORMAT
 J_SAVEPPM=2
 J_SAVEBMP
end enum

enum J_LEDFORMAT
 J_ROUND
 J_RECT
end enum
#endif

'#define J_RANDMAX 2147483647

#ifndef _DS
#define _DS declare sub
#endif

#ifndef _DF
#define _DF declare function
#endif


type cstr as zstring ptr
extern "C"
' server
_DF j_start           () as J_BOOL
_DF j_connect         (host as cstr) as integer
_DS j_quit            ()
_DS j_kill            ()
_DS j_setport         (port  as integer)
_DS j_setdebug        (level as integer)
_DS j_sync            ()

' misc.
_DS j_beep            ()
_DF j_random          () as integer
_DS j_sleep           (ms as integer)

' desktop
_DF j_getscreenheight () as integer
_DF j_getscreenwidth  () as integer

_DF j_frame           (title as cstr) as integer
_DF j_dialog          (frame as integer, title as cstr) as integer
_DF j_isresizable     (frame_dialog as integer) as J_BOOL
_DS j_setresizable    (frame_dialog as integer,s as J_BOOL)
_DS j_seticon         (frame as integer,image as integer)
_DF j_window          (frame as integer) as integer
_DF j_filedialog      (frame as integer,title as cstr, folder as cstr, file as cstr) as cstr
_DF j_fileselect      (frame as integer,title as cstr, filter as cstr, file as cstr) as cstr
_DF j_messagebox      (frame as integer,title as cstr, text as cstr) as integer
_DF j_alertbox        (frame as integer,title as cstr, text as cstr,btnCaption as cstr) as integer
_DF j_choicebox2      (frame as integer,title as cstr, text as cstr,btn1Caption as cstr,btn2Caption as cstr) as integer
_DF j_choicebox3      (frame as integer,title as cstr, text as cstr,btn1Caption as cstr,btn2Caption as cstr,btn3Caption as cstr) as integer
_DF j_printer         (frame as integer) as integer

_DF j_menubar         (frame as integer) as integer
_DF j_helpmenu        (menubar as integer,text as cstr) as integer
_DF j_menu            (menubar_menu as integer,text as cstr) as integer
_DF j_menuitem        (menu_popupmenu_helpmenu as integer,text as cstr) as integer
_DS j_setshortcut     (menuitem as integer,shortcut as ubyte)
_DF j_checkmenuitem   (menu_popupmenu_helpmenu as integer,text as cstr) as integer
_DS j_seperator       (menu_popupmenu_helpmenu as integer)
_DF j_popupmenu       (anyobj as integer, text as cstr) as integer
_DS j_showpopup       (popupmenu as integer,x as integer,y as integer)

' pbwdf = Panel or Borderpanel or Window or Dialog or Frame
_DS j_pack            (pbwdf as integer)
_DF j_button          (pbwdf as integer, text as cstr) as integer
_DF j_label           (pbwdf as integer, text as cstr) as integer
_DF j_graphicbutton   (pbwdf as integer, file as cstr) as integer
_DF j_graphiclabel    (pbwdf as integer, file as cstr) as integer
_DS j_setimage        (gfxbutton_label as integer,image as integer)
_DF j_checkbox        (pbwdf as integer, text as cstr) as integer
_DF j_canvas          (pbwdf as integer, w as integer, h as integer) as integer
_DF j_panel           (pbwdf as integer) as integer
_DF j_borderpanel     (pbwdf as integer,s as J_BORDERSTYLE) as integer
_DF j_line            (pbwdf as integer,o as J_ORIENTATION, style as integer, length as integer) as integer
_DF j_led             (pbwdf as integer,f as J_LEDFORMAT,c as J_NAMEDCOLOR) as integer

                      ' LTRB =J_LEFT or J_TOP or J_RIGHT or J_BOTTOM                  
_DF j_getinsets       (pbwdf as integer,LTRB as integer) as integer
_DF j_getlayoutid     (pbwdf as integer) as integer
_DF j_getinheight     (pbwdf as integer) as integer
_DF j_getinwidth      (pbwdf as integer) as integer
_DS j_releaseall      (pbwdf as integer)

_DF j_textfield       (pbwdf as integer,nchars as integer) as integer
_DF j_textarea        (pbwdf as integer,w as integer,h as integer) as integer

_DF j_progressbar     (pbwdf as integer,o as J_ORIENTATION) as integer
_DF j_meter           (pbwdf as integer,title as cstr) as integer
_DS j_setdanger       (meter as integer,range as integer)
_DF j_getdanger       (meter as integer) as integer

_DF j_sevensegment    (pbwdf as integer,c as J_NAMEDCOLOR) as integer

_DF j_scrollpane      (pbwdf as integer) as integer
_DF j_hscrollbar      (pbwdf_scrollplane as integer) as integer
_DF j_vscrollbar      (pbwdf_scrollplane as integer) as integer
_DF j_getviewportheight(scrollpane as integer) as integer
_DF j_getviewportwidth(scrollpane as integer) as integer
_DS j_setslidesize    (scrollbar as integer,size as integer)
_DS j_setunitinc      (scrollbar as integer,minchange as integer)
_DS j_setblockinc     (scrollbar as integer,maxchange as integer)
_DF j_getvalue        (scrollbar as integer) as integer
_DS j_setmin          (scrollbar_meter_progress as integer,value as integer)
_DS j_setmax          (scrollbar_meter_progress as integer,value as integer)
_DS j_setvalue        (scrollbar_meter_progress_sevenseg as integer,value as integer)

_DF j_radiogroup      (pbwdf as integer) as integer
_DF j_radiobutton     (radiogroup as integer, text as cstr) as integer
_DS j_setradiogroup   (radiobutton as integer,radiogroup as integer)

'list and choice
_DF j_list            (pbwdf as integer,rows as integer) as integer
_DF j_choice          (pbwdf as integer) as integer
_DS j_multiplemode    (list as integer,s as J_BOOL)
_DF j_isselect        (list as integer,item as integer) as J_BOOL
_DS j_deselect        (list as integer,item as integer)
_DS j_select          (list_choice as integer,item as integer)
_DS j_additem         (list_choice as integer,text as cstr)
_DF j_getselect       (list_choice as integer) as integer
_DS j_insert          (list_choice as integer, where as integer,text as cstr)
_DS j_remove          (list_choice as integer, item as integer)
_DS j_removeitem      (list_choice as integer, item as cstr)
_DS j_removeall       (list_choice as integer)
_DF j_getitem         (list_choice as integer,item as integer,stritem as cstr) as cstr
_DF j_getitemcount    (list_choice as integer) as integer

' layout
_DS j_setflowlayout   (pbwdf as integer,a as J_ALIGNMENT)
_DS j_setflowfill     (pbwdf as integer,state as j_BOOL)
_DS j_setborderlayout (pbwdf as integer)
_DS j_setgridlayout   (pbwdf as integer,r as integer,c as integer)
_DS j_setfixlayout    (pbwdf as integer)
_DS j_setnolayout     (pbwdf as integer)
_DS j_sethgap         (pbwdf as integer,pixels as integer)
_DS j_setvgap         (pbwdf as integer,pixels as integer)
_DS j_setinsets       (pbwdf as integer,_top as integer,_bottom as integer,_left as integer,_right as integer)
_DS j_setalign        (pbwdf as integer,mode as J_ALIGNMENT)

' all objects
_DS j_print           (anyobj as integer)
_DS j_disable         (anyobj as integer)
_DS j_enable          (anyobj as integer)
_DF j_isvisible       (anyobj as integer) as J_BOOL
_DF j_isparent        (anyobj as integer,container as integer) as J_BOOL
_DS j_setpos          (anyobj as integer,x as integer,y as integer)
_DF j_getxpos         (anyobj as integer) as integer
_DF j_getypos         (anyobj as integer) as integer
_DS j_getpos          (anyobj as integer,x as integer ptr, y as integer ptr)
_DS j_setsize         (anyobj as integer,w as integer,h as integer)
_DF j_getheight       (anyobj as integer) as integer
_DF j_getwidth        (anyobj as integer) as integer
_DS j_show            (anyobj as integer)
_DS j_add             (anyobj as integer,container as integer)
_DS j_release         (anyobj as integer)
_DS j_hide            (anyobj as integer)
_DS j_dispose         (anyobj as integer)
_DF j_getparentid     (anyobj as integer) as integer
_DS j_setfocus        (anyobj as integer)
_DS j_setborderpos    (anyobj as integer,p as integer)

_DS j_setcolor        (anyobj as integer,r as integer,g as integer,b as integer)
_DS j_setcolorbg      (anyobj as integer,r as integer,g as integer,b as integer)
_DS j_setnamedcolor   (anyobj as integer,c as J_NAMEDCOLOR)
_DS j_setnamedcolorbg (anyobj as integer,c as J_NAMEDCOLOR)

_DS j_setfont         (anyobj as integer,_name as J_FONTNAME,style as J_FONTSTYLE,size as integer)
_DS j_setfontname     (anyobj as integer,_name as J_FONTNAME)
_DS j_setfontsize     (anyobj as integer,size as integer)
_DS j_setfontstyle    (anyobj as integer,style as J_FONTSTYLE)
_DF j_getfontheight   (anyobj as integer) as integer
_DF j_getfontascent   (anyobj as integer) as integer

_DF j_getlength       (anyobj_with_text as integer) as integer
_DF j_gettext         (anyobj_with_text as integer,lpStr as cstr) as cstr
_DS j_settext         (anyobj_with_text as integer,text as cstr)
_DF j_getstringwidth  (anyobj_with_text as integer,text as cstr) as integer

'!!!
'_DS j_playsoundfile   (file as cstr)
'_DS j_play            (n as integer)
'_DF j_sound           (file as cstr) as integer


'crcl = checkbox or radiobutton or checkmenuitem or led
_DF j_getstate        (crcl as integer) as J_BOOL
_DS j_setstate        (crcl as integer,state as J_BOOL)

' afg = Text[a]rea or Text[f]ield or [G]ridlayout 
_DF j_getrows         (afg as integer) as integer
_DF j_getcolumns      (afg as integer) as integer
_DS j_setrows         (ag  as integer,r as integer)
_DS j_setcolumns      (ag  as integer,c as integer)
_DS j_setcursor       (af  as integer,c as J_CURSOR)
_DS j_delete          (a   as integer,_start as integer,_end as integer)
_DS j_replacetext     (a   as integer,text as cstr,_start as integer,_end as integer)
_DS j_appendtext      (a   as integer,text as cstr)
_DS j_inserttext      (a   as integer,text as cstr,_pos as integer)
_DS j_selectall       (af  as integer)
_DS j_selecttext      (af  as integer,_start as integer,_end as integer)
_DF j_getselstart     (af  as integer) as integer
_DF j_getselend       (af  as integer) as integer
_DF j_getseltext      (af  as integer,text as cstr) as cstr
_DF j_getcurpos       (af  as integer) as integer
_DS j_setcurpos       (af  as integer,_pos as integer)
_DS j_seteditable     (af  as integer,s as J_BOOL)
_DS j_setechochar     (f   as integer,char as byte)

' events
_DF j_getaction       () as integer
_DF j_nextaction      () as integer

' listener
_DF j_componentlistener (anyobj as integer,kind as J_COMPONETEVENT) as integer
_DF j_windowlistener  (frame_dialog_window as integer,kind as J_WINDOWEVENT) as integer

_DF j_focuslistener   (anyobj as integer) as integer
_DF j_hasfocus        (focuslistener as integer) as J_BOOL

_DF j_keylistener     (anyobj as integer) as integer
_DF j_getkeycode      (keylistener as integer) as integer
_DF j_getkeychar      (keylistener as integer) as integer

_DF j_mouselistener   (anyobj as integer,kind as J_MOUSEEVENT) as integer
_DF j_getmousex       (mouselistener as integer) as integer
_DF j_getmousey       (mouselistener as integer) as integer
_DS j_getmousepos     (mouselistener as integer, x as integer ptr, y as integer ptr)
_DF j_getmousebutton  (mouselistener as integer) as integer

' gfx section
_DF j_image           (w as integer,h as integer) as integer
_DF j_loadimage       (file as cstr) as integer
_DF j_saveimage       (obj as integer,file as cstr,J_SAVEFORMAT as integer) as integer

' cip = canvas or image or printer
_DS j_translate       (cip as integer,x as integer,y as integer)
_DS j_cliprect        (cip as integer,x as integer,y as integer,w as integer,h as integer)
_DS j_drawrect        (cip as integer,x as integer,y as integer,w as integer,h as integer)
_DS j_fillrect        (cip as integer,x as integer,y as integer,w as integer,h as integer)
_DS j_drawroundrect   (cip as integer,x as integer,y as integer,w as integer,h as integer,arcx as integer,arcy as integer)
_DS j_fillroundrect   (cip as integer,x as integer,y as integer,w as integer,h as integer,arcx as integer,arcy as integer)
_DS j_drawoval        (cip as integer,x as integer,y as integer,xr as integer,yr as integer)
_DS j_filloval        (cip as integer,x as integer,y as integer,xr as integer,yr as integer)
_DS j_drawcircle      (cip as integer,x as integer,y as integer,r as integer)
_DS j_fillcircle      (cip as integer,x as integer,y as integer,r as integer)
_DS j_drawarc         (cip as integer,x as integer,y as integer,xr as integer,yr as integer,arc1 as integer,arc2 as integer)
_DS j_fillarc         (cip as integer,x as integer,y as integer,xr as integer,yr as integer,arc1 as integer,arc2 as integer)
_DS j_drawline        (cip as integer,x1 as integer,y1 as integer,x2 as integer,y2 as integer)
_DS j_drawpolyline    (cip as integer,n as integer, xcoords as integer ptr,ycoords as integer ptr)
_DS j_drawpolygon     (cip as integer,n as integer, xcoords as integer ptr,ycoords as integer ptr)
_DS j_fillpolygon     (cip as integer,n as integer, xcoords as integer ptr,ycoords as integer ptr)
_DS j_drawpixel       (cip as integer,x as integer,y as integer)
_DS j_drawstring      (cip as integer,x as integer,y as integer,text as cstr)
_DS j_setxor          (cip as integer,state as J_BOOL)

_DS j_drawimage       (cip as integer,image as integer,x as integer,y as integer)
_DS j_drawimagesourceany alias "j_drawimagesource" (cip as integer , _ 
                       x as integer,y as integer, _
                       w as integer,h as integer, _
                       r as any ptr,g as any ptr,b as any ptr)
_DS j_drawimagesource (cip as integer , _ 
                       x as integer,y as integer, _
                       w as integer,h as integer, _
                       r as integer ptr,g as integer ptr,b as integer ptr)

_DS j_drawscaledimage (cip as integer, image as integer, _
                       sx as integer, sy as integer, _
                       sw as integer, sh as integer, _
                       dx as integer, dy as integer, _
                       dw as integer, dh as integer)

' ci = canvas or image
_DF j_getimage       (ci as integer) as integer
_DS j_getimagesource (ci as integer, _
                      x as integer    , y as integer, _
                      w as integer    , h as integer, _
                      r as integer ptr, g as integer ptr, b as integer ptr)
_DS j_getimagesourceany alias "j_getimagesource" (ci as integer, _
                      x as integer    , y as integer, _
                      w as integer    , h as integer, _
                      r as any ptr, g as any ptr, b as any ptr)

_DF j_getscaledimage (ci as integer,  _
                      sx as integer, sy as integer, _
                      sw as integer, sh as integer, _
                      dw as integer, dh as integer) as integer

end extern

#endif
